/* DecStrtoHexStr.cp */

/*
	written by
	Dr. Robert M. Delaney
	Emeritus Professor of Physics
	Saint Louis University
	6/23/05
*/

#include "DecStrtoHexStr.h"
#include <string.h>

/*
	 Calling convention:
	 Create decStr as an unsigned decimal number C string.
	 then
	 Boolean	isGoodConversion;
	 isGoodConversion = DecStrtoHexStr(hexStr);
	 if isGoodConversion is true do whatever with decStr (contains the hexadecimal number as a C string)
	 else
	 problem!
	 free(decStr); // if necessary
	 return;
*/

Boolean DecStrtoHexStr(char* decStr)
{
	long				iChar, jByte, k, length, numBytes;
	unsigned char		ch1, ch2, ten=10;
	short				carry, temp, hundred=100;
	char 				*hlookup = "0123456789ABCDEF", ch;
	
	length = strlen(decStr);
	
	if(length==0)
		return false;
	
	if(length==1)
	{
		if(decStr[0]>='0' && decStr[0]<='9')
			return true;
		else
			return false;
	}
	
	// collapse the string into numerical bytes, each byte formed from two
	// adjacent chars, starting on the right
	// the final half of the string is then the number in base 100
	iChar = jByte = length-1;
	
	while(iChar>=0)
	{
		if(iChar>0)
		{
			ch1 = decStr[iChar-1];
			ch2 = decStr[iChar];
			if(!(ch1>='0' && ch1<='9'))
				return false;
			if(!(ch2>='0' && ch2<='9'))
				return false;
			decStr[jByte--] = ten*(ch1-'0') + (ch2-'0');
		}
		else
		{
			ch2 = decStr[iChar];
			if(!(ch2>='0' && ch2<='9'))
				return false;
			decStr[jByte--] = (ch2-'0');
		}
		iChar-=2;
	}
	
	// coming out jByte+1 indexes the leading numerical byte, the last is at length-1
	
	iChar = 0; // indexes where low order hex digit will go; they will be in reverse order
	jByte++;   // now indexes leading numerical byte
	numBytes = length - jByte;
	
	while(numBytes>0)
	{
		temp = decStr[jByte];
		for(k=jByte;k<length;k++)
		{
			// get low-order 4 bits of temp
			carry = (temp & 0xF);
			if(k==length-1)
			{
				decStr[k] = (temp>>4); // new byte value after dividing by sixteen
				decStr[iChar] = hlookup[carry]; // must be after previous line
				iChar++;
			}
			else
			{
				decStr[k] = (temp>>4); // new byte value after dividing by sixteen
				temp = hundred*carry + decStr[k+1];
			}
		}
		if(decStr[jByte]==0 || iChar==length)
		{
			jByte++;
			numBytes--;
		}
	}
	
	decStr[iChar] = 0;
	
	// reverse the chars
	length = strlen(decStr);
	for(k=0;k<length/2;k++)
	{
		ch = decStr[k];
		decStr[k] = decStr[length-1-k];
		decStr[length-1-k] = ch;
	}
	
	return true;
	
}/* DecStrtoHexStr */
